"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _TreeRenderer = _interopRequireDefault(require("./TreeRenderer"));

var _measure = require("./helpers/measure");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function Container({
  children,
  tableWidth,
  availableWidth
}) {
  const scroll = tableWidth > availableWidth;
  return /*#__PURE__*/_react.default.createElement(scroll ? _reactNative.ScrollView : _reactNative.View, scroll ? {
    contentContainerStyle: {
      width: tableWidth
    },
    style: {
      width: availableWidth
    },
    horizontal: true
  } : {
    style: {
      width: tableWidth
    }
  }, children);
}
/**
 * A component to render tables.
 *
 * @param props - Props from {@link useHtmlTableProps} hook.
 *
 * @public
 */


const HTMLTable = /*#__PURE__*/(0, _react.memo)(function HTMLTable({
  layout,
  TDefaultRenderer,
  settings,
  config,
  ...props
}) {
  const tableWidth = layout.totalWidth;
  const containerWidth = settings.contentWidth;
  return /*#__PURE__*/_react.default.createElement(TDefaultRenderer, _extends({}, props, {
    style: { ...props.style,
      width: Math.min(tableWidth + (0, _measure.getHorizontalSpacing)(props.tnode.styles.nativeBlockRet), containerWidth)
    }
  }), /*#__PURE__*/_react.default.createElement(Container, {
    tableWidth: tableWidth,
    availableWidth: containerWidth
  }, /*#__PURE__*/_react.default.createElement(_TreeRenderer.default, {
    node: layout.renderTree,
    config,
    rootMarkers: props.markers
  })));
});
var _default = HTMLTable;
exports.default = _default;
//# sourceMappingURL=HTMLTable.js.map